/*
        Return To Dunes

        by Marcus Grber 28-JAN-95

        Compile:
                cl -Ox -AT rdunes.c             (Microsoft C)
                bcc -Ox -mt -tDc rdunes.c       (Borland C)
*/

#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <time.h>
#include <string.h>
#include <malloc.h>

#define MAX_POINTS 32000

unsigned char far *offscreen,far *screen=(void far *)0xA0000000;
unsigned far *_px;

long IBM;
unsigned rnd(void) { return (unsigned)(IBM=(unsigned)IBM*16807); }

#define Y_SKIP 320
#define FPOINT(p)   ( offscreen[p] )
#define FPSET(p,c)  ( screen[p]=FPOINT(p)=(unsigned char)(c) )
#define POINT(x,y)  ( offscreen[(unsigned)(y)*320+(unsigned)(x)] )
#define PSET(x,y,c) ( screen[(unsigned)(y)*320+(unsigned)(x)]=POINT(x,y)=(unsigned char)(c) )
#define PSET2(x,y,c1,c2)\
                    ( screen[(unsigned)(y)*320+(unsigned)(x)]=(unsigned char)(c1),POINT(x,y)=(unsigned char)(c2) )

int dune_it(unsigned x1,unsigned y1,unsigned x2,unsigned y2,char *vect,
            int vguard,long *frames,int *points)
{
        #define y_sgn(y) (((y)<0)?-Y_SKIP:Y_SKIP)

        int i,p;
        unsigned px,py;
        int d,jn,js,c;
        int aborted,ch,vm;
        unsigned char co,cb;
        int v[256];

        for(i=255;i>=0;i--) {
          v[i]=vect[i]*Y_SKIP;          /* rescale y for speed optimzation */
          if(v[i]==0) cb=i;             /* lowest color with v=0: "back" */
        }

        y1*=Y_SKIP;                     /* rescaly y coordinates of area */
        y2*=Y_SKIP;

        p=*points;                      /* have points already been loaded? */
        if(p<=0) {
          p=0;
          for(py=y1;py<=y2;py+=Y_SKIP)
            for(px=x1;px<=x2;px++)
              if(v[FPOINT(px+py)]) {
                _px[p]=px+py;
                if(++p==MAX_POINTS) { px=x2; py=y2; }
              }
          *points=p;                    /* return number of points */
        }

        i=0;
        d=1;
        c=((rnd()>>14)&2)-1;
        aborted=vm=0;

        while(!aborted) {
          px=_px[i];
          co = FPOINT(px);

          jn=v[co];
          js=y_sgn(jn);
          if(FPOINT(px+jn)==cb)
            { FPSET(px,cb);
              FPSET(px+jn,co);
             _px[i]+=jn; vm=1; }
          else if(FPOINT(px+c+js)==cb)
            { FPSET(px,cb);
              FPSET(px+c+js,co);
              _px[i]+=c+js; vm=1; }
          else if(jn<0 && FPOINT(px+c)==cb)
            { FPSET(px,cb);
              FPSET(px+c,co);
              _px[i]+=c; }

          i+=d;
          if(i<0 || i>=p) {
            d=(-d);
            i+=d;
            c=((rnd()>>14)&2)-1;
            if(kbhit()) {
              ch=getch(); if(ch==0 || ch==0xE0) ch=getch();
              aborted=1;
            }
            if(vguard && !vm) {
              aborted=1;
              ch=-1;                    /* special key for "steady state" */
            }
            vm=0;                       /* restart looking for vertical moves */
            (*frames)++;                /* count frames */
          }
        }
        return ch;
}

#define X1 1
#define Y1 3
#define X2 318
#define Y2 196

void main(void)
{
        union REGS r;
        unsigned px,py;
        unsigned char cx[4]={7,7,8,15};
        char v[256]={0,-1,0,0,0,0,0,2, 1,-2,0,0,0,0,0,3};
        long time0,time1,frames;
        int i,points,ch;

        _px=_fmalloc(MAX_POINTS*sizeof(*_px));
        offscreen=_fmalloc((size_t)64000);
        if(!_px || !offscreen) {
          puts("Out of memory.");
          return;
        }
        _fmemset(offscreen,0,(size_t)64000);

        time(&IBM);                     /* random number seed */

        r.x.ax=0x0013;
        int86(0x10,&r,&r);

        for(px=X1-1;px<=X2+1;px++)
          { PSET2(px,Y1-1,0,15); PSET2(px,Y1-2,0,15); PSET2(px,Y1-3,0,15);
            PSET2(px,Y2+1,0,15); PSET2(px,Y2+2,0,15); PSET2(px,Y2+3,0,15); }
        for(py=Y1;py<=Y2;py++)
          { PSET2(X1-1,py,0,15); PSET2(X2+1,py,0,15); }

        for(py=Y1;py<Y1+19;py++)
          for(px=X1;px<=X2;px++)
            { PSET(px,py,cx[(rnd()>>12)&0x03]); }
        for(py=Y2-14;py<=Y2-6;py++)
          for(px=X1;px<=X2;px++)
            { PSET(px,py,1); }
        for(py=Y2-5;py<=Y2;py++)
          for(px=X1;px<=X2;px++)
            { PSET(px,py,9); }

        points=0;                       /* must load points from image first */
        frames=0;                       /* no frames yet... */

        time(&time0);
        do {
          ch=dune_it(X1,Y1,X2,Y2,v,1,&frames,&points);
          if(ch==32 || ch==-1)          /* Space/Autoflip reverts speeds */
            for(i=0;i<sizeof(v);i++) v[i]=(-v[i]);
        } while(ch!=27);
        time(&time1);

        r.x.ax=0x0002;
        int86(0x10,&r,&r);

        printf("Speed: %ld dots/s.\n",(frames*points)/(time1-time0+1));
}
